1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
|
/*
* OTP Utilities
* Copyright (C) 2022 David M. Syzdek <david@syzdek.net>.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are
* met:
*
* * Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
* * Redistributions in binary form must reproduce the above copyright
* notice, this list of conditions and the following disclaimer in the
* documentation and/or other materials provided with the distribution.
* * Neither the name of David M. Syzdek nor the
* names of its contributors may be used to endorse or promote products
* derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
* IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL DAVID M SYZDEK BE LIABLE FOR
* ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
* OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGE.
*/
/*
* @file lib/libotputil/lmisc.c
*/
#define _LIB_LIBOTPUTIL_LMISC_C 1
#include "lmisc.h"
///////////////
// //
// Headers //
// //
///////////////
#pragma mark - Headers
#include <errno.h>
#include <stdarg.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <ctype.h>
/////////////////
// //
// Variables //
// //
/////////////////
#pragma mark - Variables
#pragma mark otputil_md_list[]
static const otputil_map_t otputil_md_list[] =
{
{ .map_name = "none", .map_id = OTPUTIL_MD_NONE },
{ .map_name = "md4", .map_id = OTPUTIL_MD_MD4 },
{ .map_name = "md5", .map_id = OTPUTIL_MD_MD5 },
{ .map_name = "sha1", .map_id = OTPUTIL_MD_SHA1 },
{ .map_name = "sha256", .map_id = OTPUTIL_MD_SHA256 },
{ .map_name = "sha512", .map_id = OTPUTIL_MD_SHA512 },
#ifdef HAVE_EVP_SHA3_256
{ .map_name = "sha3-256", .map_id = OTPUTIL_MD_SHA3_256 },
#endif
#ifdef HAVE_EVP_SHA3_512
{ .map_name = "sha3-512", .map_id = OTPUTIL_MD_SHA3_512 },
#endif
{ .map_name = NULL, .map_id = 0 },
};
/////////////////
// //
// Functions //
// //
/////////////////
#pragma mark - Functions
void
otputil_debug(
otputil_t * tud,
FILE * fs )
{
const otputil_bv_t * default_bv;
default_bv = &otputil_const_defaults_k;
tud = ((tud)) ? tud : &otputil_defaults;
fs = ((fs)) ? fs : stdout;
fprintf(fs, "OTPUtils Options:\n");
fprintf(fs, " OTPUTIL_OPT_DESC: %s\n", (((tud->util_desc)) ? tud->util_desc : "n/a"));
fprintf(fs, " OTPUTIL_OPT_METHOD: %i\n", tud->util_method);
fprintf(fs, "\n");
fprintf(fs, "HOTP (RFC 4226) Options:\n");
fprintf(fs, " OTPUTIL_OPT_HOTP_C: %" PRIu64 "\n", tud->hotp_c);
fprintf(fs, " OTPUTIL_OPT_HOTP_DIGITS: %i\n", tud->hotp_digits);
fprintf(fs, " OTPUTIL_OPT_HOTP_HMAC: %s\n", otputil_md2str(tud->hotp_hmac));
fprintf(fs, " OTPUTIL_OPT_HOTP_KSTR: %s\n", otputil_bvbase32(((tud->hotp_k)) ? tud->hotp_k : default_bv));
fprintf(fs, "\n");
fprintf(fs, "OTP (RFC 2289) Options:\n");
fprintf(fs, " OTPUTIL_OPT_OTP_ENCODE: %i\n", tud->otp_encoding);
fprintf(fs, " OTPUTIL_OPT_OTP_HASH: %s\n", otputil_md2str(tud->otp_hash));
fprintf(fs, " OTPUTIL_OPT_OTP_PASS: %s\n", (((tud->otp_pass)) ? tud->otp_pass : "n/a"));
fprintf(fs, " OTPUTIL_OPT_OTP_SEED: %s\n", (((tud->otp_seed)) ? tud->otp_seed : "n/a"));
fprintf(fs, " OTPUTIL_OPT_OTP_SEQ: %i\n", tud->otp_seq);
fprintf(fs, "\n");
fprintf(fs, "S/KEY (RFC 1760) Options:\n");
fprintf(fs, " OTPUTIL_OPT_SKEY_ENCODE: %i\n", tud->skey_encoding);
fprintf(fs, " OTPUTIL_OPT_SKEY_HASH: %s\n", otputil_md2str(tud->skey_hash));
fprintf(fs, " OTPUTIL_OPT_SKEY_PASS: %s\n", (((tud->skey_pass)) ? tud->skey_pass : "n/a"));
fprintf(fs, " OTPUTIL_OPT_SKEY_SEQ: %i\n", tud->skey_seq);
fprintf(fs, "\n");
fprintf(fs, "TOTP (RFC 6238) Options:\n");
fprintf(fs, " OTPUTIL_OPT_TOTP_DIGITS: %i\n", tud->totp_digits);
fprintf(fs, " OTPUTIL_OPT_TOTP_HMAC: %s\n", otputil_md2str(tud->totp_hmac));
fprintf(fs, " OTPUTIL_OPT_TOTP_KSTR: %s\n", otputil_bvbase32(((tud->totp_k)) ? tud->totp_k : default_bv));
fprintf(fs, " OTPUTIL_OPT_TOTP_T0: %" PRIu64 "\n", tud->totp_t0);
fprintf(fs, " OTPUTIL_OPT_TOTP_TIME: %" PRIu64 "\n", tud->totp_time);
fprintf(fs, " OTPUTIL_OPT_TOTP_X: %" PRIu64 "\n", tud->totp_tx);
return;
}
const char *
otputil_err2string(
int err )
{
switch(err)
{
case OTPUTIL_SUCCESS: return("success");
case OTPUTIL_EBADDATA: return("invalid data");
case OTPUTIL_ENOBUFS: return("no buffer space available");
case OTPUTIL_ENOMEM: return("out of virtual memory");
case OTPUTIL_ENOTSUP: return("method or feature is not supported");
case OTPUTIL_EOPTION: return("invalid option");
case OTPUTIL_EOPTVAL: return("invalid option value");
default: break;
};
return("unknown error");
}
const EVP_MD *
otputil_evp_md(
int id )
{
switch(id)
{
case OTPUTIL_MD_MD4: return(EVP_md4());
case OTPUTIL_MD_MD5: return(EVP_md5());
case OTPUTIL_MD_SHA1: return(EVP_sha1());
case OTPUTIL_MD_SHA256: return(EVP_sha256());
case OTPUTIL_MD_SHA512: return(EVP_sha512());
#ifdef HAVE_EVP_SHA3_256
case OTPUTIL_MD_SHA3_256: return(EVP_sha3_256());
#endif
#ifdef HAVE_EVP_SHA3_512
case OTPUTIL_MD_SHA3_512: return(EVP_sha3_512());
#endif
default: break;
};
return(NULL);
}
char *
otputil_getpass(
const char * prompt,
char * pass,
size_t passlen )
{
static char buff[BNDL_PASSWORD_LEN+1];
if (!(pass))
{
pass = buff;
passlen = sizeof(buff);
};
return(bindle_getpass_r(prompt, pass, passlen));
}
const char *
otputil_md2str(
int md )
{
int x;
for(x = 0; ((otputil_md_list[x].map_name)); x++)
if (md == otputil_md_list[x].map_id)
return(otputil_md_list[x].map_name);
return(NULL);
}
int
otputil_str2md(
const char * str )
{
int x;
assert(str != NULL);
for(x = 0; ((otputil_md_list[x].map_name)); x++)
if (!(strcasecmp(str, otputil_md_list[x].map_name)))
return(otputil_md_list[x].map_id);
return(-1);
}
uintmax_t
otputil_upow(
uintmax_t base,
uintmax_t exp )
{
uintmax_t result;
result = 1;
while(1)
{
if (exp & 1)
result *= base;
exp >>= 1;
if (!(exp))
return(result);
base *= base;
}
return(0);
}
/* end of source file */
|